
/*  A Bison parser, made from main.yy
 by  GNU Bison version 1.25
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	NUMERAL	258
#define	STRING	259
#define	MODEMDEV	260
#define	CTRLDEV	261
#define	CFG_MSN	262
#define	SERVER_IDENT	263
#define	ALIAS	264
#define	CONNECTION	265
#define	SRC	266
#define	DST	267
#define	MSN	268
#define	PORT	269
#define	TTY_PLUG	270
#define	CONNECT	271
#define	LISTEN	272
#define	STOP	273
#define	QUIT	274
#define	INFO	275
#define	LIST	276
#define	DUMP	277
#define	LOGOPT	278
#define	POLL	279
#define	MSG	280
#define	EOL	281

#line 1 "main.yy"

#include <config.h>

#include <stdio.h>
#include <string.h>

#include <map>

#include "line.h"
#include "scanner.h"
#include "discovery.h"
#include "util.h"
#include "global.h"

using namespace std;

static msn last_chat;

static char servername[40];

msn cfg_country;
msn cfg_area;
msn cfg_msn;

typedef map<const string, connection *, string_less_than> con_map;
con_map connections;
struct mask_map mask_map;
ctrl_connection control_connection;

void con_apply (const char *id, connection::message f, const char *msg = 0)
{
  con_map::iterator p = connections.find (id);
  if (p != connections.end ())
    {
      if (msg) printf ("%s -> %s: ", id, msg), fflush (stdout);
      (p->second->*f) ();
      if (msg) printf ("done\n");
    }
  else
    fprintf (stderr, "%s: no such connection\n", id);
}

#define CFG_TIMEOUT 5000

int num_connections ()
{
  int count = 0;
  con_map::const_iterator i = connections.begin ();
  
  while (i != connections.end ())
    count++, i++;
  
  return count;
}

/* wire functions */
packet ctrl_connection::send_packet ()
{
  packet p;
  
  lock.lock ();
  if (once ())
    {
      p = once;
      once.reset ();
      tx_at (5000);
    }
  else if (sent ())
    {
      if (ie_mask m = mask_map.dst_mask (sent.dst_msn))
        {
          sent.mask = m;
          p = sent;
          sent.reset ();
        }
    }
  
  lock.unlock ();
  return p;
}

void ctrl_connection::send_ctrl_poll (const char *src, const char *dst, u8 reply)
{
  lock.lock ();
  sent.set (src, dst, IEM_NONE);
  sent.put (MSG_CFG);
  sent.put (CFG_POLL | reply);
  sent.put (PROTOCOL_VERSION);
  
  sent.put (num_connections ());
  
  for(char *c = servername; *c; c++)
    sent.put (*c);
  
  sent.put (0);
  lock.unlock ();
}

void ctrl_connection::receive_packet (const packet &p)
{
  lock.lock ();
  
  disc_timeout.reset ();
  log (L_JUNK, "config packet %02x received\n", (int)p[0]);
  if (p[0] == MSG_DISCOVERY)
    {
      disc_timeout.reset ();
      
      mask_map.lock.lock ();
      ie_masks &m = mask_map[p.src_msn];
      mask_map.lock.unlock ();
      
      m.src = p.mask; // point of discovery ;)
      if (p[1])
        m.dst = p[1];
      
      if (m.dst && m.src)
        log (L_DISC, "SERVER MASKS DISCOVERED: %s (%02x) -> %s (%02x)\n",
                      p.dst_msn, m.src, p.src_msn, m.dst);
      
      // other side needs information? need to ack..
      if (!(p[1] && p[2]))
        {
          log (L_DISC, "ack'ing discovery packet (%02x, %02x)\n", m.src, m.dst);
          once.set (p.dst_msn, p.src_msn, m.dst ? m.dst : IEM_ALL);
          once.put (MSG_DISCOVERY);
          once.put (m.src);
          once.put (m.dst);
          while (once.size () < MAX_PACKET)
            once.put (0);
        }
      
      tx_now ();
    }
  else if (p[0] == MSG_CFG)
    switch (p[1] & ~CFG_REPLY)
      {
        case CFG_POLL:
          log (L_WARN, "SERVER POLL %s (%s) protocolversion %d, %d connections\n",
                        p.src_msn, &p[4], p[2], p[3]);
          if (!(p[1] & CFG_REPLY))
            send_ctrl_poll (p.dst_msn, p.src_msn, CFG_REPLY);
          break;
        
        case CFG_MSG:
          {
            char dt[40];
            time_t tt = time (0);
            
            strftime (dt, 40, "%a %H:%M:%S", localtime (&tt));
            printf ("\r%s MESSAGE FROM %s: '", dt, p.src_msn);
            packet::const_iterator i = p.begin (); i++; i++;
            while (i != p.end ())
              putc (*i++, stdout);
            printf ("'\n");
            break;
          }
        
        default:
          log (L_WARN, "WARNING: unknown MSG_CFG (%02x) received!!\n", p[1]);
      }
  else if (p[0] == MSG_RST)
    {
      log (L_WARN, "warning, RESET received from %s\n", p.src_msn);
      line_control.command_all (&connection::reset, p.src_msn);
    }
  else if ((p[0] & MSG_MASK) == MSG_SYN)
    {
      log (L_INFO, "connection request ignored from %s, pver %d, port %d -> %d\n",
           p.src_msn, p[1], p[2], p[3]);
      send_rst (p);
    }
  else
    {
      log (L_WARN, "WARNING: unknown config packet %02x received!!\n", (int)p[0]);
      send_rst (p);
    }
  
  lock.unlock ();
}

void mask_map::dump ()
{
  const_iterator i = begin ();
  
  while (i != end ())
    {
      printf ("%s: %02x -> %02x\n", i->first.c_str (), i->second.src, i->second.dst);
      ++i;
    }
}

ie_mask mask_map::dst_mask (const char *dst)
{
  ie_masks &m = operator [](dst);
  
  if (m.src && m.dst)
    return m.dst;
  
  static timestamp last_discover;
  
  if (last_discover.past ())
    {
      packet &p = control_connection.once;
      
      control_connection.lock.lock ();
      last_discover.stamp (control_connection.disc_timeout ());
      control_connection.disc_timeout.next ();
      p.set (cfg_msn, dst, IEM_ALL);
      p.put (MSG_DISCOVERY);
      p.put (m.src);
      p.put (m.dst);
      while (p.size () < MAX_PACKET)
        p.put (0);
      
      control_connection.once = p;
      control_connection.tx_now ();
      control_connection.lock.unlock ();
    }
  
  return IEM_NONE;
}

#define YYERROR_VERBOSE

void yyerror (const char *msg)
{
  fprintf (stderr, "%s, line %d: %s\n", yyfilename, yylineno, msg);
}

// connection setup parameters
static plug *plg;
static char id[40];
static msn src;
static u8 src_port;
static msn dst;
static u8 dst_port;


#line 241 "main.yy"
typedef union {
   char str[1024];
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		80
#define	YYFLAG		-32768
#define	YYNTBASE	29

#define YYTRANSLATE(x) ((unsigned)(x) <= 281 ? yytranslate[x] : 40)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    27,     2,    28,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     3,     6,     7,    10,    14,    18,    24,    28,
    30,    32,    34,    35,    45,    46,    50,    52,    56,    60,
    64,    68,    71,    75,    79,    83,    87,    90,    94,    97,
   101,   104,   107,   110,   113,   116
};

static const short yyrhs[] = {    31,
     0,     0,    26,    30,     0,     0,    31,    32,     0,     5,
     4,    26,     0,     6,     4,    26,     0,     7,     3,     3,
     3,    26,     0,     8,     4,    26,     0,    33,     0,    38,
     0,    26,     0,     0,    10,     4,    30,    34,    27,    30,
    35,    28,    26,     0,     0,    36,    30,    35,     0,    37,
     0,    11,    13,     3,     0,    12,    13,     3,     0,    11,
    14,     3,     0,    12,    14,     3,     0,    15,     4,     0,
    16,     4,    26,     0,    17,     4,    26,     0,    18,     4,
    26,     0,    20,     4,    26,     0,    21,    26,     0,    24,
     3,    26,     0,    22,    26,     0,    25,     3,     4,     0,
    25,     4,     0,    23,    26,     0,    23,    39,     0,    19,
    26,     0,     4,    39,     0,    26,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   260,   262,   262,   264,   264,   266,   268,   270,   273,   275,
   276,   277,   280,   282,   311,   311,   313,   314,   316,   318,
   320,   324,   328,   330,   332,   334,   336,   346,   348,   350,
   353,   355,   357,   358,   362,   364
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","NUMERAL",
"STRING","MODEMDEV","CTRLDEV","CFG_MSN","SERVER_IDENT","ALIAS","CONNECTION",
"SRC","DST","MSN","PORT","TTY_PLUG","CONNECT","LISTEN","STOP","QUIT","INFO",
"LIST","DUMP","LOGOPT","POLL","MSG","EOL","'{'","'}'","config_file","eol","decls",
"decl","connection","@1","connection_tags","connection_tag","plug","command",
"logopts", NULL
};
#endif

static const short yyr1[] = {     0,
    29,    30,    30,    31,    31,    32,    32,    32,    32,    32,
    32,    32,    34,    33,    35,    35,    36,    36,    36,    36,
    36,    37,    38,    38,    38,    38,    38,    38,    38,    38,
    38,    38,    38,    38,    39,    39
};

static const short yyr2[] = {     0,
     1,     0,     2,     0,     2,     3,     3,     5,     3,     1,
     1,     1,     0,     9,     0,     3,     1,     3,     3,     3,
     3,     2,     3,     3,     3,     3,     2,     3,     2,     3,
     2,     2,     2,     2,     2,     1
};

static const short yydefact[] = {     4,
     1,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    12,     5,    10,    11,
     0,     0,     0,     0,     2,     0,     0,     0,    34,     0,
    27,    29,     0,    32,    33,     0,     0,    31,     6,     7,
     0,     9,     2,    13,    23,    24,    25,    26,    36,    35,
    28,    30,     0,     3,     0,     8,     2,    15,     0,     0,
     0,     0,     2,    17,     0,     0,     0,     0,    22,     0,
    15,    18,    20,    19,    21,    14,    16,     0,     0,     0
};

static const short yydefgoto[] = {    78,
    44,     1,    18,    19,    55,    62,    63,    64,    20,    35
};

static const short yypact[] = {-32768,
     8,     5,     6,    14,    15,    16,    32,    33,    34,    13,
    36,    17,    18,    -4,    39,     1,-32768,-32768,-32768,-32768,
    19,    20,    44,    22,    23,    24,    25,    26,-32768,    27,
-32768,-32768,    -3,-32768,-32768,    28,    51,-32768,-32768,-32768,
    53,-32768,    23,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,    31,-32768,    35,-32768,    23,    -9,    -6,    -2,
    54,    37,    23,-32768,    56,    57,    58,    60,-32768,    38,
    -9,-32768,-32768,-32768,-32768,-32768,-32768,    66,    67,-32768
};

static const short yypgoto[] = {-32768,
   -22,-32768,-32768,-32768,-32768,    -1,-32768,-32768,-32768,    40
};


#define	YYLAST		73


static const short yytable[] = {    33,
    33,    59,    60,    37,    38,    61,    65,    66,    21,    22,
    67,    68,     2,     3,     4,     5,    23,     6,    24,    25,
    54,    34,    49,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    58,    26,    27,    28,    29,    30,
    71,    36,    31,    32,    39,    40,    41,    42,    43,    45,
    46,    47,    48,    51,    52,    53,    56,    69,    72,    73,
    74,    57,    75,    76,    70,    79,    80,     0,     0,    77,
     0,     0,    50
};

static const short yycheck[] = {     4,
     4,    11,    12,     3,     4,    15,    13,    14,     4,     4,
    13,    14,     5,     6,     7,     8,     3,    10,     4,     4,
    43,    26,    26,    16,    17,    18,    19,    20,    21,    22,
    23,    24,    25,    26,    57,     4,     4,     4,    26,     4,
    63,     3,    26,    26,    26,    26,     3,    26,    26,    26,
    26,    26,    26,    26,     4,     3,    26,     4,     3,     3,
     3,    27,     3,    26,    28,     0,     0,    -1,    -1,    71,
    -1,    -1,    33
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 196 "/usr/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 6:
#line 267 "main.yy"
{ line_control.add_modemdev (yyvsp[-1].str); ;
    break;}
case 7:
#line 269 "main.yy"
{ line_control.set_ctrldev (yyvsp[-1].str); ;
    break;}
case 8:
#line 271 "main.yy"
{ strcpy (cfg_country, yyvsp[-3].str); strcpy (cfg_area, yyvsp[-2].str); strcpy (cfg_msn, yyvsp[-1].str);
			  normalize_msn (cfg_msn); ;
    break;}
case 9:
#line 274 "main.yy"
{ strcpy (servername, yyvsp[-1].str); ;
    break;}
case 13:
#line 281 "main.yy"
{ src_port = dst_port = 0; plg = 0; src[0] = 0; dst[0] = 0; strcpy (id, yyvsp[-1].str); ;
    break;}
case 14:
#line 283 "main.yy"
{
			  if (!plg)
                	    yyerror ("plug tag missing");
                	  else if (!src[0])
                	    yyerror ("src tag missing");
                	  else if (!dst[0])
                	    yyerror ("dst tag missing");
                	  else
                	    {
                	      if (!src_port)
                	        {
                	          log (L_WARN, "WARNING: defaulting src_port to %d\n", PORT_ITCP);
                	          src_port = PORT_ITCP;
                	        }
                	      if (!dst_port)
                	        {
                	          log (L_WARN, "WARNING: defaulting dst_port to %d\n", PORT_ITCP);
                	          dst_port = PORT_ITCP;
                	        }
                	      normalize_msn (src);
                	      normalize_msn (dst);
                	      connection *nc = new itcp_connection (src, src_port, dst, dst_port, *plg);
                	      printf ("adding itcp_connection %s: ", id); nc->dump ();
			      connections[ strdup(id) ] = nc;
			    }
                	;
    break;}
case 18:
#line 315 "main.yy"
{ strcpy (src, yyvsp[0].str); ;
    break;}
case 19:
#line 317 "main.yy"
{ strcpy (dst, yyvsp[0].str); ;
    break;}
case 20:
#line 319 "main.yy"
{ src_port = atoi (yyvsp[0].str); ;
    break;}
case 21:
#line 321 "main.yy"
{ dst_port = atoi (yyvsp[0].str); ;
    break;}
case 22:
#line 325 "main.yy"
{ if (plg) delete plg; plg = new tty_plug (yyvsp[0].str); ;
    break;}
case 23:
#line 329 "main.yy"
{ con_apply (yyvsp[-1].str, &connection::connect, "connect"); ;
    break;}
case 24:
#line 331 "main.yy"
{ con_apply (yyvsp[-1].str, &connection::listen, "listen"); ;
    break;}
case 25:
#line 333 "main.yy"
{ con_apply (yyvsp[-1].str, &connection::stop, "stop"); ;
    break;}
case 26:
#line 335 "main.yy"
{ con_apply (yyvsp[-1].str, &connection::dump); ;
    break;}
case 27:
#line 337 "main.yy"
{
			  con_map::iterator p = connections.begin ();
			  while (p != connections.end ())
			    {
			      printf ("%s: ", p->first.c_str ());
			      p->second->dump ();
			      ++p;
			    }
			;
    break;}
case 28:
#line 347 "main.yy"
{ normalize_msn (yyvsp[-1].str); control_connection.cfg_poll (yyvsp[-1].str); ;
    break;}
case 29:
#line 349 "main.yy"
{ mask_map.dump (); ;
    break;}
case 30:
#line 351 "main.yy"
{ strcpy (last_chat, yyvsp[-1].str); normalize_msn (last_chat);
			  control_connection.chat (last_chat, yyvsp[0].str); ;
    break;}
case 31:
#line 354 "main.yy"
{ control_connection.chat (last_chat, yyvsp[0].str); ;
    break;}
case 32:
#line 356 "main.yy"
{ parse_logopt (0); ;
    break;}
case 34:
#line 359 "main.yy"
{ exit (0); ;
    break;}
case 35:
#line 363 "main.yy"
{ parse_logopt (yyvsp[-1].str); ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 498 "/usr/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 367 "main.yy"


int main (int argc, char *argv[])
{
  assert (argc == 2);
  
  init_debug (argv);
  
#if YYDEBUG != 0
  yydebug = 1;
#endif
  
  yyin = fopen (argv [1], "r");
  assert (yyin);
  yyfilename = argv [1];
  yylineno = 1;
  
  line_control.add_connection (&control_connection);
  
  for(;;)
    yyparse ();
  
  return 0;
}

