#include "thread++.h"

mutex::mutex(int recursive)
{
  pthread_mutexattr_t ma;
  
  pthread_mutexattr_settype (&ma, recursive ? PTHREAD_MUTEX_RECURSIVE_NP : PTHREAD_MUTEX_FAST_NP);
  pthread_mutex_init (&m, &ma);
}

//******************************************************************************************
// thread abstractions

struct thread_context {
  runnable *ths;
  runnable::thread method;
  void *arg;
};

static void *runnable_run_stub (void *cp)
{
  thread_context c = *(thread_context *)cp;
  delete (thread_context *)cp; // stress allocator ;)
  return (c.ths->*(c.method)) (c.arg);
}

int runnable::run (pthread_t *tid, thread t, void *arg)
{
  thread_context *c = new thread_context;
  
  c->ths = this;
  c->method = t;
  c->arg = arg;
  
  pthread_attr_t attr;
  pthread_attr_init (&attr);
  
  return pthread_create (tid, &attr, runnable_run_stub, (void *)c);
}


